addpath  NN

%% load data
% load data;
% train_x - training data (# of samples by input dimension)
% train_y - training labels (# of samples by # of classes)
% test_x - test data
% test_y - test labels

%% training with explicit control of weight sparsity
nn = nnsetup([784 100 10]);             
nn.activation_function = 'tanh';
nn.output = 'softmax';
nn.learningRate = 0.001;
nn.weightPenaltyL1 = [0 0]; % L1-norm regularization term
nn.weightPenaltyL2 = [0 0]; % L2-norm regularization term
nn.nzr = [0.2 0.0];	% target weight sparsity level 
nn.beginAnneal = 100; % epoch index when learning rate decay starts
nn.max_beta = [0.01 0.01]; % maximum beta values

% train nn
opts.numepochs = 300;
opts.batchsize = 100;
nn = nntrain(nn, train_x, train_y, opts, test_x, test_y);
er = nn.loss.val.e_frac(end);
